/[gentoo-x86]/net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r3.ebuild
Gentoo

Contents of /net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r3.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.5 - (show annotations) (download)
Thu Jul 7 07:54:54 2011 UTC (9 years ago) by gurligebis
Branch: MAIN
CVS Tags: HEAD
Changes since 1.4: +1 -1 lines
FILE REMOVED
Cleaning bug and fixing bugs #373921 and #374089

(Portage version: 2.2.0_alpha43/cvs/Linux i686)

1 # Copyright 1999-2011 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r3.ebuild,v 1.4 2011/07/01 20:01:04 gurligebis Exp $
4
5 EAPI="2"
6
7 inherit eutils toolchain-funcs qt4-r2 systemd multilib
8
9 DESCRIPTION="IEEE 802.1X/WPA supplicant for secure wireless transfers"
10 HOMEPAGE="http://hostap.epitest.fi/wpa_supplicant/"
11 SRC_URI="http://hostap.epitest.fi/releases/${P}.tar.gz"
12 LICENSE="|| ( GPL-2 BSD )"
13
14 SLOT="0"
15 KEYWORDS="~amd64 ~arm ~ppc ~ppc64 ~x86 ~x86-fbsd"
16 IUSE="dbus debug gnutls eap-sim fasteap madwifi ps3 qt4 readline ssl wimax wps kernel_linux kernel_FreeBSD"
17
18 RDEPEND="dbus? ( sys-apps/dbus )
19 kernel_linux? (
20 eap-sim? ( sys-apps/pcsc-lite )
21 madwifi? ( ||
22 ( >net-wireless/madwifi-ng-tools-0.9.3
23 net-wireless/madwifi-old )
24 )
25 dev-libs/libnl
26 )
27 !kernel_linux? ( net-libs/libpcap )
28 qt4? ( x11-libs/qt-gui:4
29 x11-libs/qt-svg:4 )
30 readline? ( sys-libs/ncurses sys-libs/readline )
31 wimax? ( !net-wireless/libeap )
32 ssl? ( dev-libs/openssl )
33 !ssl? ( gnutls? ( net-libs/gnutls ) )
34 !ssl? ( !gnutls? ( dev-libs/libtommath ) )"
35 DEPEND="${RDEPEND}
36 dev-util/pkgconfig"
37
38 S="${WORKDIR}/${P}/${PN}"
39
40 pkg_setup() {
41 if use fasteap && (use gnutls || use ssl) ; then
42 die "If you use fasteap, you must build with wpa_supplicant's internal TLS implementation. That is, both 'gnutls' and 'ssl' USE flags must be disabled"
43 fi
44
45 if use gnutls && use ssl ; then
46 einfo "You have both 'gnutls' and 'ssl' USE flags enabled: defaulting to USE=\"ssl\""
47 fi
48 }
49
50 src_prepare() {
51 # net/bpf.h needed for net-libs/libpcap on Gentoo/FreeBSD
52 sed -i \
53 -e "s:\(#include <pcap\.h>\):#include <net/bpf.h>\n\1:" \
54 ../src/l2_packet/l2_packet_freebsd.c || die
55
56 # People seem to take the example configuration file too literally (bug #102361)
57 sed -i \
58 -e "s:^\(opensc_engine_path\):#\1:" \
59 -e "s:^\(pkcs11_engine_path\):#\1:" \
60 -e "s:^\(pkcs11_module_path\):#\1:" \
61 wpa_supplicant.conf || die
62
63 # Change configuration to match Gentoo locations (bug #143750)
64 sed -i \
65 -e "s:/usr/lib/opensc:/usr/$(get_libdir):" \
66 -e "s:/usr/lib/pkcs11:/usr/$(get_libdir):" \
67 wpa_supplicant.conf || die
68
69 epatch "${FILESDIR}/${P}-dbus_path_fix.patch"
70
71 if use wimax; then
72 cd "${WORKDIR}/${P}"
73 epatch "${FILESDIR}/${P}-generate-libeap-peer.patch"
74
75 # multilib-strict fix (bug #373685)
76 sed -e "s/\/usr\/lib/\/usr\/$(get_libdir)/" -i src/eap_peer/Makefile
77 fi
78
79 # bug (320097)
80 epatch "${FILESDIR}/do-not-call-dbus-functions-with-NULL-path.patch"
81 # https://bugzilla.gnome.org/show_bug.cgi?id=644634
82 epatch "${FILESDIR}/${P}-dbus-api-changes.patch"
83 }
84
85 src_configure() {
86 # Toolchain setup
87 echo "CC = $(tc-getCC)" > .config
88
89 # Basic setup
90 echo "CONFIG_CTRL_IFACE=y" >> .config
91 echo "CONFIG_BACKEND=file" >> .config
92
93 # Basic authentication methods
94 # NOTE: we don't set GPSK or SAKE as they conflict
95 # with the below options
96 echo "CONFIG_EAP_GTC=y" >> .config
97 echo "CONFIG_EAP_MD5=y" >> .config
98 echo "CONFIG_EAP_OTP=y" >> .config
99 echo "CONFIG_EAP_PAX=y" >> .config
100 echo "CONFIG_EAP_PSK=y" >> .config
101 echo "CONFIG_EAP_TLV=y" >> .config
102 echo "CONFIG_IEEE8021X_EAPOL=y" >> .config
103 echo "CONFIG_PKCS12=y" >> .config
104 echo "CONFIG_PEERKEY=y" >> .config
105 echo "CONFIG_EAP_LEAP=y" >> .config
106 echo "CONFIG_EAP_MSCHAPV2=y" >> .config
107 echo "CONFIG_EAP_PEAP=y" >> .config
108 echo "CONFIG_EAP_TLS=y" >> .config
109 echo "CONFIG_EAP_TTLS=y" >> .config
110
111 if use dbus ; then
112 echo "CONFIG_CTRL_IFACE_DBUS=y" >> .config
113 echo "CONFIG_CTRL_IFACE_DBUS_NEW=y" >> .config
114 echo "CONFIG_CTRL_IFACE_DBUS_INTRO=y" >> .config
115 fi
116
117 if use debug ; then
118 echo "CONFIG_DEBUG_FILE=y" >> .config
119 fi
120
121 if use eap-sim ; then
122 # Smart card authentication
123 echo "CONFIG_EAP_SIM=y" >> .config
124 echo "CONFIG_EAP_AKA=y" >> .config
125 echo "CONFIG_EAP_AKA_PRIME=y" >> .config
126 echo "CONFIG_PCSC=y" >> .config
127 fi
128
129 if use fasteap ; then
130 echo "CONFIG_EAP_FAST=y" >> .config
131 fi
132
133 if use readline ; then
134 # readline/history support for wpa_cli
135 echo "CONFIG_READLINE=y" >> .config
136 fi
137
138 # SSL authentication methods
139 if use ssl ; then
140 echo "CONFIG_TLS=openssl" >> .config
141 echo "CONFIG_SMARTCARD=y" >> .config
142 elif use gnutls ; then
143 echo "CONFIG_TLS=gnutls" >> .config
144 echo "CONFIG_GNUTLS_EXTRA=y" >> .config
145 else
146 echo "CONFIG_TLS=internal" >> .config
147 fi
148
149 if use kernel_linux ; then
150 # Linux specific drivers
151 echo "CONFIG_DRIVER_ATMEL=y" >> .config
152 #echo "CONFIG_DRIVER_BROADCOM=y" >> .config
153 #echo "CONFIG_DRIVER_HERMES=y" >> .config
154 echo "CONFIG_DRIVER_HOSTAP=y" >> .config
155 echo "CONFIG_DRIVER_IPW=y" >> .config
156 echo "CONFIG_DRIVER_NDISWRAPPER=y" >> .config
157 echo "CONFIG_DRIVER_NL80211=y" >> .config
158 #echo "CONFIG_DRIVER_PRISM54=y" >> .config
159 echo "CONFIG_DRIVER_RALINK=y" >> .config
160 echo "CONFIG_DRIVER_WEXT=y" >> .config
161 echo "CONFIG_DRIVER_WIRED=y" >> .config
162
163 if use madwifi ; then
164 # Add include path for madwifi-driver headers
165 echo "CFLAGS += -I/usr/include/madwifi" >> .config
166 echo "CONFIG_DRIVER_MADWIFI=y" >> .config
167 fi
168
169 if use ps3 ; then
170 echo "CONFIG_DRIVER_PS3=y" >> .config
171 fi
172
173 elif use kernel_FreeBSD ; then
174 # FreeBSD specific driver
175 echo "CONFIG_DRIVER_BSD=y" >> .config
176 fi
177
178 # Wi-Fi Protected Setup (WPS)
179 if use wps ; then
180 echo "CONFIG_WPS=y" >> .config
181 fi
182
183 # Enable mitigation against certain attacks against TKIP
184 echo "CONFIG_DELAYED_MIC_ERROR_REPORT=y" >> .config
185
186 if use qt4 ; then
187 cd "${S}"/wpa_gui-qt4
188 eqmake4 wpa_gui.pro
189 fi
190 }
191
192 src_compile() {
193 einfo "Building wpa_supplicant"
194 emake || die "emake failed"
195
196 if use wimax; then
197 emake -C ../src/eap_peer clean || die "emake failed"
198 emake -C ../src/eap_peer || die "emake failed"
199 fi
200
201 if use qt4 ; then
202 cd "${S}"/wpa_gui-qt4
203 einfo "Building wpa_gui"
204 emake || die "wpa_gui compilation failed"
205 fi
206 }
207
208 src_install() {
209 dosbin wpa_supplicant || die
210 dobin wpa_cli wpa_passphrase || die
211
212 # baselayout-1 compat
213 if has_version "<sys-apps/baselayout-2.0.0"; then
214 dodir /sbin
215 dosym /usr/sbin/wpa_supplicant /sbin/wpa_supplicant || die
216 dodir /bin
217 dosym /usr/bin/wpa_cli /bin/wpa_cli || die
218 fi
219
220 if has_version ">=sys-apps/openrc-0.5.0"; then
221 newinitd "${FILESDIR}/${PN}-init.d" wpa_supplicant
222 newconfd "${FILESDIR}/${PN}-conf.d" wpa_supplicant
223 fi
224
225 exeinto /etc/wpa_supplicant/
226 newexe "${FILESDIR}/wpa_cli.sh" wpa_cli.sh
227
228 dodoc ChangeLog {eap_testing,todo}.txt README{,-WPS} \
229 wpa_supplicant.conf || die "dodoc failed"
230
231 doman doc/docbook/*.{5,8} || die "doman failed"
232
233 if use qt4 ; then
234 into /usr
235 dobin wpa_gui-qt4/wpa_gui || die
236 doicon wpa_gui-qt4/icons/wpa_gui.svg || die "Icon not found"
237 make_desktop_entry wpa_gui "WPA Supplicant Administration GUI" "wpa_gui" "Qt;Network;"
238 fi
239
240 if use wimax; then
241 emake DESTDIR="${D}" -C ../src/eap_peer install || die
242 fi
243
244 if use dbus ; then
245 cd "${S}"/dbus
246 insinto /etc/dbus-1/system.d
247 newins dbus-wpa_supplicant.conf wpa_supplicant.conf || die
248 insinto /usr/share/dbus-1/system-services
249 doins fi.epitest.hostap.WPASupplicant.service fi.w1.wpa_supplicant1.service || die
250 keepdir /var/run/wpa_supplicant
251 fi
252
253 # SystemD stuff
254 systemd_dounit "${FILESDIR}"/wpa_supplicant.service
255 systemd_newunit "${FILESDIR}"/wpa_supplicant_at.service 'wpa_supplicant@.service' || die
256 }
257
258 pkg_postinst() {
259 einfo "If this is a clean installation of wpa_supplicant, you"
260 einfo "have to create a configuration file named"
261 einfo "/etc/wpa_supplicant/wpa_supplicant.conf"
262 einfo
263 einfo "An example configuration file is available for reference in"
264 einfo "/usr/share/doc/${PF}/"
265
266 if [[ -e ${ROOT}etc/wpa_supplicant.conf ]] ; then
267 echo
268 ewarn "WARNING: your old configuration file ${ROOT}etc/wpa_supplicant.conf"
269 ewarn "needs to be moved to ${ROOT}etc/wpa_supplicant/wpa_supplicant.conf"
270 fi
271
272 if use madwifi ; then
273 echo
274 einfo "This package compiles against the headers installed by"
275 einfo "madwifi-old, madwifi-ng or madwifi-ng-tools."
276 einfo "You should re-emerge ${PN} after upgrading these packages."
277 fi
278 }

  ViewVC Help
Powered by ViewVC 1.1.20